package com.zt.plat.module.erp.service.erp;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpWarehousePageReqVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpWarehouseRespVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpWarehouseSaveReqVO;
import com.zt.plat.module.erp.dal.dataobject.erp.ErpWarehouseDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * ERP库位 Service 接口
 *
 * @author 后台管理
 */
public interface ErpWarehouseService {

    /**
     * 创建ERP库位
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ErpWarehouseRespVO createErpWarehouse(@Valid ErpWarehouseSaveReqVO createReqVO);

    /**
     * 更新ERP库位
     *
     * @param updateReqVO 更新信息
     */
    void updateErpWarehouse(@Valid ErpWarehouseSaveReqVO updateReqVO);

    /**
     * 删除ERP库位
     *
     * @param id 编号
     */
    void deleteErpWarehouse(Long id);

    /**
    * 批量删除ERP库位
    *
    * @param ids 编号
    */
    void deleteErpWarehouseListByIds(List<Long> ids);

    /**
     * 获得ERP库位
     *
     * @param id 编号
     * @return ERP库位
     */
    ErpWarehouseRespVO getErpWarehouse(Long id);

    ErpWarehouseDO getErpWarehouse(String id);
    /**
     * 获得ERP库位分页
     *
     * @param pageReqVO 分页查询
     * @return ERP库位分页
     */
    PageResult<ErpWarehouseDO>  getErpWarehousePage(ErpWarehousePageReqVO pageReqVO);

    void callErpRfcInterface();

    void enableWarehouseList(List<ErpWarehouseSaveReqVO> saveReqVOS);

    PageResult<ErpWarehouseDO> getErpWarehousePageDistinctByFactory(ErpWarehousePageReqVO pageReqVO);
}